package com.insomnia.GUI;

import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class RequestPanel extends JPanel {

    private VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    private JPanel body = new JPanel();
    private JPanel auth = new JPanel();
    private JPanel query = new JPanel();
    private JPanel mainCenterHeader = new JPanel(vfLayout);
    private JScrollPane scrollPane_Header_Request = new JScrollPane(mainCenterHeader);
    JPanel docs = new JPanel();
    JTabbedPane tabbedPaneCenterRequest = new JTabbedPane();
    JTextField headerField = new JTextField("header");
    JTextField valueField = new JTextField("value");
    JCheckBox checkBox = new JCheckBox();
    JButton delete = new JButton();
    JPanel rightOfHeader = new JPanel();
    JPanel center_header = new JPanel(new GridLayout(1,2));
    JPanel header = new JPanel(new BorderLayout());
    String s []={"Patch","Put","Post","Delete","Get"};
    JComboBox centerMenu = new JComboBox(s);
    JTextField URLTextField = new JTextField("http://api.myproduct.com/v1/users");
    JButton sendButton = new JButton("send");
    JPanel centerUp = new JPanel(new BorderLayout());


    public JTabbedPane tabbedPaneCenterRequest() throws IOException {
        Border border = BorderFactory.createLineBorder(Color.BLACK,3);
        BufferedImage master;
        master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
        Image scaled = master.getScaledInstance(20,20, java.awt.Image.SCALE_SMOOTH);
        body.setBackground(Color.GRAY);
        auth.setBackground(Color.GRAY);
        query.setBackground(Color.GRAY);
        mainCenterHeader.setBackground(Color.GRAY);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        docs.setBackground(Color.GRAY);
        //request-center
        tabbedPaneCenterRequest.setBackground(Color.GRAY);
        tabbedPaneCenterRequest.add("Body" , body);
        tabbedPaneCenterRequest.add("Auth" , auth);
        tabbedPaneCenterRequest.add("Query" , query);
        tabbedPaneCenterRequest.add("Header" , scrollPane_Header_Request);
        tabbedPaneCenterRequest.add("Docs" , docs);
        headerField.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                JButton newDelete = new JButton();
                newDelete.setPreferredSize(new Dimension(20,20));
                newDelete.setIcon(new ImageIcon(scaled));
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader );

            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        RequestPanel.TextFieldHandler textFieldHandler = new TextFieldHandler(headerField,mainCenterHeader,border);//create a actionListener
        headerField.setFocusable(true);
        headerField.addActionListener( textFieldHandler);
        headerField.setBorder(border);
        valueField.setBorder(border);
        delete.setIcon(new ImageIcon(scaled));
        delete.setPreferredSize(new Dimension(20,20));
        rightOfHeader.add(checkBox);
        rightOfHeader.add(delete);
        center_header.add(headerField);
        center_header.add(valueField);
        header.add(rightOfHeader,BorderLayout.EAST);
        header.add(center_header,BorderLayout.CENTER);
        mainCenterHeader.add(header);
        return tabbedPaneCenterRequest;
    }

    //request_up
    public JPanel centerUp(){

        centerMenu.setFont(new Font("Arial",20,15 ));
        centerUp.add(centerMenu , BorderLayout.WEST);
        centerUp.add(URLTextField , BorderLayout.CENTER);
        centerUp.add(sendButton , BorderLayout.EAST);
        return centerUp;
    }

    class TextFieldHandler implements ActionListener {
        JTextField headerField ;
        JPanel mainCenterHeader;
        Border border;
        private TextFieldHandler(JTextField headerField , JPanel mainCenterHeader , Border border){
            this.headerField = headerField;
            this.mainCenterHeader = mainCenterHeader;
            this.border = border;
        }
        @Override
        public void actionPerformed(ActionEvent e) {
            System.out.println("++++++++++++");
            if (!headerField.getText().equals("") ) {
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                JButton newDelete = new JButton(new ImageIcon("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\1000582.png"));
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader);
            }
        }
    }

    public void createRequestPanel() throws IOException {
        addToMainRequestPanel(centerUp() , tabbedPaneCenterRequest());
    }

    public void addToMainRequestPanel(JPanel centerUp ,JTabbedPane tabbedPaneCenterRequest ){
        this.setLayout(new BorderLayout());
        this.add(centerUp,BorderLayout.NORTH);
        this.add(tabbedPaneCenterRequest , BorderLayout.CENTER);
    }


    public JPanel getRightOfHeader() {
        return rightOfHeader;
    }

    public JPanel getCenter_header() {
        return center_header;
    }

    public JPanel getBody() {
        return body;
    }

    public JPanel getAuth() {
        return auth;
    }

    public JPanel getQuery() {
        return query;
    }

    public JPanel getMainCenterHeader() {
        return mainCenterHeader;
    }

    public JScrollPane getScrollPane_Header_Request() {
        return scrollPane_Header_Request;
    }

    public JPanel getDocs() {
        return docs;
    }

    public JTabbedPane getTabbedPaneCenterRequest() {
        return tabbedPaneCenterRequest;
    }

    public JPanel getHeader() {
        return header;
    }

    public JComboBox getCenterMenu() {
        return centerMenu;
    }

    public JPanel getCenterUp() {
        return centerUp;
    }
}
